/***************************************************************************
 * Copyright 2012 by
 *  + Christian-Albrechts-University of Kiel
 *    + Department of Computer Science
 *      + Software Engineering Group 
 *  and others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ***************************************************************************/

package kieker.webgui.common;

import java.io.IOException;
import java.util.Collection;
import java.util.HashMap;

import kieker.analysis.AnalysisController.STATE;
import kieker.analysis.model.analysisMetaModel.MIProject;
import kieker.webgui.common.exception.AnalysisStateException;
import kieker.webgui.common.exception.DisplayNotFoundException;
import kieker.webgui.common.exception.NewerProjectException;
import kieker.webgui.common.exception.ProjectAlreadyExistingException;
import kieker.webgui.common.exception.ProjectNotExistingException;

import org.primefaces.model.UploadedFile;

/**
 * This is an implemented facade for the project management. For technical reasons it is a singleton class.
 * 
 * @author Nils Christian Ehmke
 * @version 1.0
 */
public final class ProjectManagerFacade implements IProjectManagerFacade {

	private final HashMap<String, Object> fileSystemLocks = new HashMap<String, Object>();
	private final HashMap<String, Object> analysesLocks = new HashMap<String, Object>();

	/**
	 * This is the private constructor for this class, as this class is a singleton.
	 */
	private ProjectManagerFacade() {
		// No code necessary.
	}

	public static ProjectManagerFacade getInstance() {
		return null;
	}

	@Override
	public void addProject(final String projectName) throws ProjectAlreadyExistingException, IOException {
		// TODO Auto-generated method stub

	}

	@Override
	public void copyProject(final String originalProjectName, final String newProjectName) throws ProjectNotExistingException, ProjectAlreadyExistingException,
			IOException {
		// TODO Auto-generated method stub

	}

	@Override
	public MIProject openProject(final String projectName) throws ProjectNotExistingException, IOException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Object openProject(final String projectName, final ClassAndMethodContainer classAndMethodContainer) throws ProjectNotExistingException, IOException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void saveProject(final String projectName, final MIProject project, final long timeStamp, final boolean overwriteNewerProject)
			throws ProjectNotExistingException, IOException, NewerProjectException {
		// TODO Auto-generated method stub

	}

	@Override
	public long getCurrTimeStamp(final String projectName) throws ProjectNotExistingException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public void uploadLibrary(final UploadedFile file, final String projectName) throws ProjectNotExistingException, IOException {
		// TODO Auto-generated method stub

	}

	@Override
	public ClassLoader getClassLoader(final String projectName) throws ProjectNotExistingException, IOException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Collection<String> listAllLibraries(final String projectName) throws ProjectNotExistingException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Collection<String> listAllProjects() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void initializeAnalysis(final String projectName) throws ProjectNotExistingException, AnalysisStateException {
		// TODO Auto-generated method stub

	}

	@Override
	public void cleanAnalysis(final String projectName) throws ProjectNotExistingException, AnalysisStateException {
		// TODO Auto-generated method stub

	}

	@Override
	public void startAnalysis(final String projectName) throws ProjectNotExistingException, AnalysisStateException {
		// TODO Auto-generated method stub

	}

	@Override
	public void stopAnalysis(final String projectName) throws ProjectNotExistingException, AnalysisStateException {
		// TODO Auto-generated method stub

	}

	@Override
	public Object getDisplay(final String projectName, final String viewName, final String displayName) throws ProjectNotExistingException, DisplayNotFoundException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public STATE getCurrentState(final String projectName) throws ProjectNotExistingException {
		// TODO Auto-generated method stub
		return null;
	}

}
